
#define BLYNK_PRINT Serial
#include <OneWire.h>
#include <DallasTemperature.h>
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <time.h>

BlynkTimer timer;

WidgetTerminal terminal(V1);

#define ONE_WIRE_BUS 2
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);

char auth[] = "your blynk code";
char ssid[] = "your SSID";
char pass[] = "your password";
#define ESP8266_BAUD 115200
ESP8266 wifi(&Serial);

int timer1=0;
int arm=0;
int watercount = 0;
int count = 0;

void sendSensor()
{
 sensors.requestTemperatures();
 float temp=sensors.getTempCByIndex(0);
 float real_temp=(temp-6.5);
 Blynk.virtualWrite(V5, real_temp);
}

void setup(void)
{
 Serial.begin(9600);
 delay(10);
 Serial.begin(ESP8266_BAUD);
 delay(10);
 Blynk.begin(auth, wifi, ssid, pass);

 pinMode(11, OUTPUT);
 digitalWrite(11, LOW);
 
 sensors.begin();
 timer.setInterval(1000L, sendSensor);

 terminal.clear();
 terminal.print("Welcome to the Gardening App");
 terminal.println();
 terminal.flush();
}

BLYNK_WRITE(V2)
{
  timer1 = param.asInt();
}

BLYNK_WRITE(V3)
{
  arm = param.asInt();
}

BLYNK_WRITE(V1)
{
    if (String("check") == param.asStr()) {
    terminal.println("The system is online.") ;
    terminal.println();
       if(timer1==HIGH){
        terminal.print("Timer: ACTIVE");
        terminal.println();
       }
       if(timer1==LOW){
        terminal.print("Timer: STANDBY");
        terminal.println();
       }
       if(arm==HIGH){
        terminal.print("Arm: SYSTEM ARMED");
        terminal.println();
       }
       if(arm=LOW){
        terminal.print("Arm: SYSTEM DISARMED");
        terminal.println();
       }
    }
    
    else{
    terminal.print("Unknown command: ");
    terminal.write(param.getBuffer(), param.getLength());
    terminal.println();
    terminal.println();
    }
  terminal.flush();
}

void loop(void)
{
 Blynk.run();
 timer.run();
 
 if ((timer1 == HIGH) && (arm == HIGH))  {
    digitalWrite(11, HIGH);
    if(count==0){
    terminal.print("Pump in function...");
    terminal.println();
    terminal.flush();
    count=2;
    watercount++;
    }
    }
 else{
    digitalWrite(11, LOW);
    if(count==2){
    terminal.print("Pump stopped.");
    terminal.println();
    terminal.print("Activations count: ");
    terminal.print(watercount);
    terminal.println();
    terminal.println();
    terminal.flush();
    count=0;
    }
    }
} 





